/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		geometria.h													***/
/***	popis:		hlavicka modulu geometria.cpp	 							***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#ifndef _GEOMETRIA_H_
#define _GEOMETRIA_H_

#include "randomc.h"


// vypocet obvodu prstenca
float TPerim(osg::Vec3 & a, osg::Vec3 & b, unsigned int pocet);

// vypocet uhlu alfa
float AlfaComp(float dx, float dy);

// rozptyl bodov vetvy
void RozptylV(osg::Vec3 & bod, float x0, float y0, float z0, float rozptyl, TRandomMersenne & rg);

// transformacia smeroveho vektoru vetvy
void SMTrans(float x, float y, float z, float & dx, float & dy, float & dz, osg::Vec3 k_vektor);

// vplyv gravitacie a zakrivenia smerom hore
void GTrans(float & dx, float & dy, float & dz, float uhol);

// vypocet suradnic povrchovych bodov
void VertComp(osg::Vec3 pred,osg::Vec3 aktual,osg::Vec3 next,float polomer,
			  osg::Vec3Array & krBody, osg::Vec3Array & normaly, int pocet);

#endif // _GEOMETRIA_H_

