/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		hud.cpp														***/
/***	popis:		funkcia generujuca OSD 										***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#include <osg/Geometry>
#include <osg/Texture2D>
#include <osg/Projection>
#include <osg/MatrixTransform>
#include <osgDB/ReadFile>
#include <osgText/Text>

#include "hud.h"


// ::::::::::::::::::::::::::: funkcia OnSD :::::::::::::::::::::::::::::::::::::::
// vytvorenie OSD
//
osg::Projection* OnSD(void)
{
	osg::Geode* OSDGeo = new osg::Geode();
	osg::Geometry* OSDGeometry = new osg::Geometry();
	osg::Vec3Array* OSDVert = new osg::Vec3Array;
	osg::DrawElementsUInt* OSDElement = new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
	osg::Vec4Array* OSDcolor = new osg::Vec4Array;
	osg::Vec2Array* TexCoor = new osg::Vec2Array(4);
	osg::Texture2D* OSDTexture = new osg::Texture2D;
	osg::Vec3Array* OSDnorm = new osg::Vec3Array;
	osg::StateSet* OSDStateSet = new osg::StateSet();
	osgText::Text* hlavicka = new osgText::Text();
	osgText::Text* klavesy = new osgText::Text();
	osgText::Text* instrukcie = new osgText::Text();
	osg::Image* osdImage;
   
	// vytvorenie a inicializacia projekcnej matice, 
	// definovanie horiznotalnych a vertikalnych hranic,
	osg::Projection* OSDProMatrix = new osg::Projection;
	OSDProMatrix->setMatrix(osg::Matrix::ortho2D(0,1024,0,768));

	// pre "model view" sa pouzije matica identity
	osg::MatrixTransform* OSDModelViewMatrix = new osg::MatrixTransform;
	OSDModelViewMatrix->setMatrix(osg::Matrix::identity());
	OSDModelViewMatrix->setReferenceFrame(osg::Transform::ABSOLUTE_RF);

	// vrcholy geometrie OSD
	OSDVert->push_back(osg::Vec3(700,	20,		-1));
    OSDVert->push_back(osg::Vec3(1000,	20,		-1));
    OSDVert->push_back(osg::Vec3(1000,	170,	-1));
    OSDVert->push_back(osg::Vec3(700,	170,	-1));

	OSDElement->push_back(0);
	OSDElement->push_back(1);
	OSDElement->push_back(2);
	OSDElement->push_back(3);

	// farba
	OSDcolor->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.8f));

	// normala
	OSDnorm->push_back(osg::Vec3(0.0f,0.0f,1.0f));

	// koordinaty textury
	(*TexCoor)[0].set(0.0f,0.0f);
	(*TexCoor)[1].set(1.0f,0.0f);
	(*TexCoor)[2].set(1.0f,1.0f);
	(*TexCoor)[3].set(0.0f,1.0f);

	// textura
	osdImage = osgDB::readImageFile("hud_tex.png");
	OSDTexture->setDataVariance(osg::Object::DYNAMIC);
	OSDTexture->setImage(osdImage);
	
	// state-set
	//  povoli sa "alfa blending", zakaze sa "depth testing" 
	//  a zabezpeci sa aby sa OSD renderoval ako posledny
	//
	OSDStateSet->setTextureAttributeAndModes(0,OSDTexture,osg::StateAttribute::ON);
	OSDStateSet->setMode(GL_BLEND,osg::StateAttribute::ON);
	OSDStateSet->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
	OSDStateSet->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );
	OSDStateSet->setRenderBinDetails( 1024, "RenderBin");

	// text
	hlavicka->setCharacterSize(20);
	hlavicka->setFont("impact.ttf");
	hlavicka->setText("Genertor stromov");
	hlavicka->setAxisAlignment(osgText::Text::SCREEN);
	hlavicka->setPosition(osg::Vec3(720, 147, -1.5));
	hlavicka->setColor(osg::Vec4(1.0, 1.0, 1.0, 1));

	klavesy->setCharacterSize(15);
	klavesy->setFont("arialbd.ttf");
	klavesy->setText("<RIGHT>\n<LEFT>\n<DEL>\n<ESC>");
	klavesy->setAxisAlignment(osgText::Text::SCREEN);
	klavesy->setPosition(osg::Vec3(720, 100, -1.5));
	klavesy->setColor(osg::Vec4(0.0, 0.0, 0.0, 1));

	instrukcie->setCharacterSize(15);
	instrukcie->setFont("arial.ttf");
	instrukcie->setText("nasledujci strom\npredchdzajci strom\non/off OSD\nkoniec");
	instrukcie->setAxisAlignment(osgText::Text::SCREEN);
	instrukcie->setPosition(osg::Vec3(790, 100, -1.5));
	instrukcie->setColor(osg::Vec4(0.0, 0.0, 0.0, 1));
	
	
	OSDGeometry->setTexCoordArray(0,TexCoor);
	OSDGeometry->setNormalArray(OSDnorm);
	OSDGeometry->setNormalBinding(osg::Geometry::BIND_OVERALL);
	OSDGeometry->addPrimitiveSet(OSDElement);
	OSDGeometry->setVertexArray(OSDVert);
	OSDGeometry->setColorArray(OSDcolor);
	OSDGeometry->setColorBinding(osg::Geometry::BIND_OVERALL);
	
	OSDGeo->setStateSet(OSDStateSet);
	OSDGeo->addDrawable(OSDGeometry);
	OSDGeo->addDrawable(hlavicka);
	OSDGeo->addDrawable(klavesy);
	OSDGeo->addDrawable(instrukcie);
	OSDModelViewMatrix->addChild(OSDGeo);
	OSDProMatrix->addChild(OSDModelViewMatrix);
	
	return OSDProMatrix;
	//*
}