/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		ovladanie.cpp												***/
/***	popis:		ovladanie demonstracnej aplikacie 							***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#include <osgProducer/Viewer>
#include "ovladanie.h"

#define RIGHT 65363
#define LEFT 65361
#define DEL 65535
#define POCET 7

using namespace std;

// globalne
int st_index = 2;							// index aktualneho stromu
bool osdb = true;							// zobrazit/nezobrazit OSD
osg::Switch* base = new osg::Switch;		// prepinac stromov
osg::Switch* osd_switch = new osg::Switch;	// prepinac OSD


// ::::::::::::::::::::::::::: handle metoda :::::::::::::::::::::::::::::::::::::::::::
//
bool myKeyboardEventHandler::handle(const osgGA::GUIEventAdapter& ea,osgGA::GUIActionAdapter& aa)
{
	switch(ea.getEventType())
	{
		case(osgGA::GUIEventAdapter::KEYDOWN):
		{
			switch(ea.getKey())
			{
				case RIGHT:
				{
					st_index++;
					st_index %= POCET;

					base->setSingleChildOn(st_index);

					return false;
					break;
				}

				case LEFT:
				{
					st_index--;
					if (st_index < 0)
						st_index = POCET - 1;

					base->setSingleChildOn(st_index);

					return false;
					break;
				}

				case DEL:
				{
					osdb = !osdb;
					
					if (osdb)
						osd_switch->setSingleChildOn(0);
					else
						osd_switch->setAllChildrenOff();

					return false;
					break;
				}
				
				default:
					return false;
			} 
		}
		
		default:
			return false;
   }
}