/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		parser.cpp													***/
/***	popis:		nacitanie parametrov zo suboru								***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iostream>
#include <string>
#include <vector>

#include "parser.h"

using namespace std;


// ::::::::::::::::::::::::::: funkcia GetParam :::::::::::::::::::::::::::::::::::
// ziskanie parametrov zo suboru
//
int GetParam(tparam & parametre, string c_subor)
{
	ifstream subor;
	string atribut;
	string hodnota;
	int t_pocet = 0;				// pocet textur listov
	
	subor.open(c_subor.c_str());
	if (!subor)
	{
		// nepodarilo sa otvoric konfiguracny subor
		cout << "nepodarilo sa otovrit config. subor: " << c_subor << " !" << endl;
		return -1;
	}

	while (getline(subor, atribut, '='))
	{
		// atribut je nacitany, nacita sa hodnota
		getline(subor, hodnota, '\n');

		// odstrania sa biele znaky na konci hodnoty
		if (hodnota.find_first_of(" \t") != string::npos)
			hodnota.erase(hodnota.find_first_of(" \t"));
		
		// ................... urcenie atributu a ziskanie prislusej hodnoty ......
		// 
		if (atribut.compare("VYSKA_STROMU") == 0)
			parametre.vyska_stromu = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("MAX_ROZPTYL_KMEN") == 0)
			parametre.max_rozptyl_kmen = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("SIRKA_VYSKA") == 0)
			parametre.sirka_vyska = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("KORUNA_KMEN") == 0)
			parametre.koruna_kmen = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("SEG_VET") == 0)
			parametre.seg_vet = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("SEG_KMEN") == 0)
			parametre.seg_kmen = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("ALFA_KOR") == 0)
			parametre.alfa_kor = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V_ROZPTYL") == 0)
			parametre.v_rozptyl = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("KRV_POMER") == 0)
			parametre.krv_pomer = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("VRV_POMER") == 0)
			parametre.vrv_pomer = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("LSPH_POLOMER") == 0)
			parametre.lsph_polomer = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("LSPH_POCET") == 0)
			parametre.lsph_pocet = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("LBIL_DLZKA") == 0)
			parametre.lbil_dlzka = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("LBIL_SIRKA") == 0)
			parametre.lbil_sirka = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("LBIL_UHOL") == 0)
			parametre.lbil_uhol = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("L_VELKOST") == 0)
			parametre.l_velkost = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("LTEX_POCET") == 0)
			parametre.ltex_pocet = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("SPH_LISTY") == 0)
		{
			if ((hodnota.compare("TRUE") == 0) || (hodnota.compare("true") == 0))
				parametre.sph_listy = true;
			else
				parametre.sph_listy = false;
		}
		else if (atribut.compare("BIL_LISTY") == 0)
		{
			if ((hodnota.compare("TRUE") == 0) || (hodnota.compare("true") == 0))
				parametre.bil_listy = true;
			else
				parametre.bil_listy = false;
		}
		else if (atribut.compare("OKR_KORUNA") == 0)
		{
			if ((hodnota.compare("TRUE") == 0) || (hodnota.compare("true") == 0))
				parametre.okr_koruna = true;
			else
				parametre.okr_koruna = false;
		}
		else if (atribut.compare("V1G_POCET") == 0)
			parametre.v1G_pocet = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("BIL_TRANSLUC") == 0)
			parametre.bil_transluc = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("K_SUBOR") == 0)
			parametre.k_subor = hodnota;
		
		else if (atribut.compare("H_TEX_MUL") == 0)
			parametre.hTexMul = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("V_TEX_MUL") == 0)
			parametre.vTexMul = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("V1G_UHOL") == 0)
			parametre.v1G_uhol = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("UHP") == 0)
			parametre.uhp = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("NEXTG_POMER") == 0)
			parametre.nextG_pomer = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V1G_GRAV") == 0)
			parametre.v1G_grav = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V1G_SUN") == 0)
			parametre.v1G_sun = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V2GENER") == 0)
		{
			if ((hodnota.compare("TRUE") == 0) || (hodnota.compare("true") == 0))
			{
				parametre.v2gener = true;
			}
			else
			{
				parametre.v2gener = false;
			}
		}
		else if (atribut.compare("V2G_UHOL") == 0)
			parametre.v2G_uhol = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V2G_GRAV") == 0)
			parametre.v2G_grav = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V2G_SUN") == 0)
			parametre.v2G_sun = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V2G_MAX") == 0)
			parametre.v2G_max = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V3GENER") == 0)
		{
			if ((hodnota.compare("TRUE") == 0) || (hodnota.compare("true") == 0))
				parametre.v3gener = true;
			else
				parametre.v3gener = false;
		}
		else if (atribut.compare("V3G_UHOL") == 0)
			parametre.v3G_uhol = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V3G_GRAV") == 0)
			parametre.v3G_grav = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V3G_SUN") == 0)
			parametre.v3G_sun = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("V3G_MAX") == 0)
			parametre.v3G_max = (float)atof(hodnota.c_str());
		
		else if (atribut.compare("DETAIL") == 0)
			parametre.detail = (int)atoi(hodnota.c_str());
		
		else if (atribut.compare("TEX_SUBORY") == 0)
		{
			int c_pocet = (int)hodnota.length();
			string t_subor;
			
			// odstranenie defaultnej textury
			parametre.tex_subory.clear();		
			
			// ziskanie textur zo suboru
			for (int i = 0; i < c_pocet; i++)
			{
				if (hodnota[i] == ',')
				{
					parametre.tex_subory.push_back(t_subor);
					t_pocet++;
					t_subor.erase();
				}
				else
				{
					t_subor.push_back(hodnota[i]);
				}
			}

			if (!t_subor.empty())
			{
				parametre.tex_subory.push_back(t_subor);
				t_pocet++;
			}	
		}
		else
			cout << "neznamy atribut: " << atribut.c_str() << ", ignoruje sa ... " << endl;
	}

	if (t_pocet < parametre.ltex_pocet)
	{
		cout << "chyba v konf. subore: zadany pocet textur listov sa nezhoduje s poctom suborov" << endl;
		return -1;
	}
	
	subor.close();
	return 0;
	//*
}