/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		parser.h													***/
/***	popis:		hlavicka modulu parser.cpp	 							***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#ifndef _PARSER_H_
#define _PARSER_H_


using namespace std;

// parametre generatoru
struct tparam
{
	float	vyska_stromu;			// vyska stromu
	float	max_rozptyl_kmen;		// maximum rozptylu kontrolnych bodov kmena
	float	sirka_vyska;			// pomer: sirka stromu / vyska stromu
	float	koruna_kmen;			// pomer: vyska koruny / vyska kmena
	float	seg_vet;				// segmentacia vetiev (realne cislo)
	int		seg_kmen;				// segmentacia hmena (integer!)
	float	alfa_kor;				// korekcia rozsahov nahodnych hodnot smeroveho uhla vetiev
	float	v_rozptyl; 				// miera rozptylu kontrolnych bodov vetvy (float)
	float	krv_pomer;				// pomer: spodny polomer kmena / vyska stromu
	float	vrv_pomer;				// pomer: spodny polomer vetvy / dlzka vetvy
	float	lsph_polomer;			// vzdialenost listov od stredu (sfericka metoda)
	int		lsph_pocet;				// pocet listov v zhluku (sfericka metoda)
	float	lbil_dlzka;				// dlzka listoveho bilbordu (bilbordova metoda)
	float	lbil_sirka;				// sirka listoveho bilbordu (bilbordova metoda)
	float	lbil_uhol;				// vzajomny uhol listoveho bilbordu a vetvy
	float	l_velkost;				// velkost listu (sfericka metoda)
	int		ltex_pocet;				// pocet roznych textur listu
	bool	sph_listy;				// 1 - zobrazit listy - sfef. metoda, 0 - listy nezobrazovat
	bool	bil_listy;				// 1 - zobrazit listy - bil. metoda, 0 - listy nezobrazovat
	bool	okr_koruna;				// 1 - okruhla koruna, 0 - kuzelova
	int		v1G_pocet;				// pocet vetvi 1G vyrastajucich z jedneho k_bodu
	float	bil_transluc;			// priesvitnost bilbordu (0 - 1)

	std::string k_subor;	// subor s texturou kory
	int		hTexMul;				// horizontalny nasobitel textury kory (integer)
	int		vTexMul;				// vertikalny nasobitel textury kory (integer)

	// vetvy 1. generacie
	float	v1G_uhol;				// vzajomy uhol kmena a smer. vektora vetvy (rad)
	float	uhp;					// prirastok uhla kmena a vetvy
	float	nextG_pomer;			// pomer: usek vetvy z kt. vyrastaju vetvy nasledujucej generacie / cela vetva
	float	v1G_grav;				// vplyv gravitacie
	float	v1G_sun;				// miera zakrivenia smerom hore
	
	// vetvy 2. generacie
	bool	v2gener;				// 1 - zobrazit vetvy 2. genracie, 0 - nezobrazit ...
	float	v2G_uhol;				// vzajomy uhol vetvy a rodicovskej vetvy (rad)
	float	v2G_grav;				// vplyv gravitacie
	float	v2G_sun;				// miera zakrivenia smerom hore
	float	v2G_max;				// maximalna dlzka vetvy

	// vetvy 3. generacie
	bool	v3gener;				// 1 - zobrazit vetvy 2. genracie, 0 - nezobrazit ...
	float	v3G_uhol;				// vzajomy uhol vetvy a rodicovskej vetvy (rad)
	float	v3G_grav;				// vplyv gravitacie
	float	v3G_sun;				// miera zakrivenia smerom hore
	float	v3G_max;				// maximalna dlzka vetvy

	int		detail;					// glob. detaily: 3-najvyssie, 2-stredne, 1-nizke	
						
	// textury listov
	std::vector<std::string> tex_subory;

};


// nacitanie parametrov zo suboru
int GetParam(tparam & parametre, string c_subor);


#endif // _PARSER_H_
