/**********************************************************************************/
/***	projekt:	Generator stromov, bakalarska praca							***/
/***	autor:		Tomas Pafco, xpafco00@stud.fit.vutbr.cz						***/
/***	rok:		2006/2007													***/
/***																			***/
/***	subor:		tex.cpp														***/
/***	popis:		nacitanie a zostavovanie textur 							***/
/***																			***/
/***	poznamky:	vytvorene vo Visual Studiu 2003 pod WinXP					***/
/***																			***/
/**********************************************************************************/

#include <osg/Geometry>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <math.h>
#include <iostream>

#include "tex.h"
#include "randomc.h"

using namespace std;


// kontajner textur
std::vector<osg::Texture2D*> textury;


// ::::::::::::::::::::::::::: funkcia KoraL ::::::::::::::::::::::::::::::::::::::
// nacitanie a zostavenie textury kory
//
osg::Texture2D* KoraL(std::string subor)
{
	osg::Image* img = new osg::Image;
	osg::Texture2D* tex = new osg::Texture2D;
	
	img = osgDB::readImageFile(subor);
	if (img == NULL)
	{
		cout << "textura kory sa nenasla" << endl;
		return NULL;
	}
	else
	{
		tex->setImage(img);
		tex->setDataVariance(osg::Object::DYNAMIC);
	}
	
	return tex;
	//*
}




// ::::::::::::::::::::::::::: funkcia ListTex ::::::::::::::::::::::::::::::::::::
// nastavenie textury pre konkretny list
//
void ListTex(osg::StateSet & stSet, TRandomMersenne & rg)
{
	int pocetTex = textury.size();
	int index = (int)(XRandom(0, pocetTex-1, rg) + 0.5);

	osg::Texture2D* tex = textury[index];
	
	stSet.setTextureAttributeAndModes(0,tex,osg::StateAttribute::ON);
	stSet.setMode(GL_BLEND,osg::StateAttribute::ON);
    stSet.setRenderingHint(osg::StateSet::TRANSPARENT_BIN);
	
}




// ::::::::::::::::::::::::::: funkcia TexLoud ::::::::::::::::::::::::::::::::::::
// nacitanie obrazkov z disku a zostavenie textur
//
int TexLoud(int pocet, std::vector<string> tex_subory)
{
	osg::Image* img = new osg::Image;
	int i;

	for (i = 0; i < pocet; i++)
	{
		img = osgDB::readImageFile(tex_subory[i]);
		if (img != NULL)
		{
			osg::Texture2D* tex = new osg::Texture2D;
			tex->setImage(img);
			tex->setDataVariance(osg::Object::DYNAMIC);
			textury.push_back(tex);
		}
		else
		{
			cout << "missing texture file: " << tex_subory[i] << " !" << endl;
			return -1;
		}

	}

	return 0;
	//*
}